# Bazaar merge directive format 2 (Bazaar 0.90)
# revision_id: marian.edu@acorn.ro-20220214085025-sjhs35fa61crw5gw
# target_branch: sftp://medu@xfer.goldencode.com/opt/fwd/3821c
# testament_sha1: 816c6ece9597b538fc4de8147ac131088cd5853c
# timestamp: 2022-02-14 10:50:35 +0200
# base_revision_id: ca@goldencode.com-20220211104335-lnjxpgnygkwabkgx
# 
# Begin patch
=== modified file 'rules/annotations/method_defs.rules'
--- rules/annotations/method_defs.rules	2021-04-28 15:44:53 +0000
+++ rules/annotations/method_defs.rules	2021-10-28 07:59:30 +0000
@@ -34,6 +34,7 @@
 **     CA  20210203 Fixed a regression in invokeStandalone or invoke, for Progress.Lang.Class.
 **     CA  20210221 Copy 'qualified' annotation for property getter, to emit at the signature.
 **     CA  20210428 Fixed o:getClass():invoke() when it needs to be emitted as 'invokeStandalone'.
+**     ME  20211027 Fixed property class name when no getter defined (only set).
 */
 -->
 
@@ -296,9 +297,9 @@
             isAbstract = isIface or (copy.parent.isAnnotation("abstract") and
                                      getReferenceNoteBoolean(copy.parent.id, "abstract"))
          </action>
+         <action>cls = copy.parent.getAnnotation("classname")</action>
          
          <rule>type == prog.kw_get
-            <action>cls = copy.parent.getAnnotation("classname")</action>
             <rule>cls.equals("object") or cls.equals("jobject")
                <action>
                   objtype = copy.parent.getAnnotation("full-java-class")

=== modified file 'rules/annotations/naming.rules'
--- rules/annotations/naming.rules	2021-11-11 01:28:12 +0000
+++ rules/annotations/naming.rules	2022-02-11 15:26:27 +0000
@@ -48,6 +48,7 @@
 **                           the imported class name is the same name as the program with the 
 **                           import statement.
 **     CA  20210609          Fixed extent property used as output/input-output argument.
+**     ME  20211022          Send the AST node as input to loadConvertedClass call.
 **     OM  20211111          Added transaction support for finally blocks.
 */
  -->
@@ -298,7 +299,7 @@
          <!-- this needs to be done first -->
          <action>setConvertedClassName(file, ooname, fullpkg, classname)</action>
          <!-- map the source file name to the converted class naming info -->
-         <action>cclass = loadConvertedClass(file, true)</action>
+         <action>cclass = loadConvertedClass(file, true, this)</action>
       </rule>
       
       <rule>relativePath("METHOD_DEF/KW_METHOD/SYMBOL")

=== modified file 'rules/annotations/oo_references.rules'
--- rules/annotations/oo_references.rules	2021-07-08 15:49:35 +0000
+++ rules/annotations/oo_references.rules	2021-10-28 07:59:30 +0000
@@ -39,6 +39,7 @@
 **                  later on, when that is injected, the proper javaname is used.
 **     GES 20210701 Fix class name references which are to static members of a parent class. This is a 4GL
 **                  quirk.
+**     ME  20211022 Send the AST node as input to loadConvertedClass call.
 */
  -->
  
@@ -237,8 +238,10 @@
                <rule on="false">true
                   <!-- explicit class import -->
                   <action>fname = getNoteString("source-file")</action>
-                  <action>nameinfo = loadConvertedClass(fname, false)</action>
-                  <action>putNote("legacy-import", nameinfo.getQualifiedName())</action>
+                  <action>nameinfo = loadConvertedClass(fname, false, this)</action>
+                  <rule>nameinfo != null
+                     <action>putNote("legacy-import", nameinfo.getQualifiedName())</action>
+                  </rule>
                </rule>
             </rule>
          </rule>
@@ -274,7 +277,7 @@
             isNote("qualified") and isNote("source-file")
 
          <action>fname = getNoteString("source-file")</action>
-         <action>nameinfo = loadConvertedClass(fname, false)</action>
+         <action>nameinfo = loadConvertedClass(fname, false, this)</action>
          
          <rule>nameinfo != null
             <action>oname = nameinfo.getQualifiedName()</action>
@@ -307,7 +310,7 @@
          <action>copy.parent.putAnnotation("source-file", getNoteString("source-file"))</action>
 
          <action>fname = getNoteString("source-file")</action>
-         <action>nameinfo = loadConvertedClass(fname, false)</action>
+         <action>nameinfo = loadConvertedClass(fname, false, this)</action>
          
          <rule>nameinfo != null
             <action>copy.parent.putAnnotation("full-java-class", nameinfo.getQualifiedName())</action>
@@ -327,7 +330,7 @@
       
       <rule>this.type == prog.enum_value
          <action>fname = getNoteString("source-file")</action>
-         <action>nameinfo = loadConvertedClass(fname, false)</action>
+         <action>nameinfo = loadConvertedClass(fname, false, this)</action>
          
          <rule>nameinfo != null
             <action>copy.putAnnotation("full-java-class", nameinfo.getQualifiedName())</action>
@@ -465,7 +468,7 @@
             
             <rule on="false">true
                <action>fname = getNoteString("found-in-source-file")</action>
-               <action>nameinfo = loadConvertedClass(fname, false)</action>
+               <action>nameinfo = loadConvertedClass(fname, false, this)</action>
                <rule>nameinfo != null
                   <rule>isNote("refid")
                      <!-- use the javaname at the refid, and not what we thing we should convert to -->
@@ -578,7 +581,7 @@
       <rule>this.type == prog.class_event
          <!-- annotate the event name -->
          <action>fname = getNoteString("found-in-source-file")</action>
-         <action>nameinfo = loadConvertedClass(fname, false)</action>
+         <action>nameinfo = loadConvertedClass(fname, false, this)</action>
          <action>refid = getNoteLong("refid")</action>
          
          <rule>refid == null
@@ -613,7 +616,7 @@
           (copy.parent.type == prog.object_invocation and evalLib("input_argument", copy.parent)))
             
          <action>fname = getNoteString("cls-container")</action>
-         <action>nameinfo = loadConvertedClass(fname, false)</action>
+         <action>nameinfo = loadConvertedClass(fname, false, this)</action>
          <action>refid = getNoteLong("refid")</action>
          
          <rule>refid == null
@@ -872,7 +875,7 @@
             !(isNote("cls-property") or getNoteBoolean("cls-property"))
             
          <action>fname = getNoteString("found-in-source-file")</action>
-         <action>nameinfo = loadConvertedClass(fname, false)</action>
+         <action>nameinfo = loadConvertedClass(fname, false, this)</action>
          
          <!-- member vars -->
          <rule>!isNote("refid") and (!isNote("cls-property") or !getNoteBoolean("cls-property"))

=== modified file 'rules/convert/literals.rules'
--- rules/convert/literals.rules	2021-11-02 22:08:37 +0000
+++ rules/convert/literals.rules	2022-02-11 15:26:27 +0000
@@ -144,6 +144,7 @@
 **     CA  20210818          Emit 'instantiateUnknownMemptr' in cases when an unknown argument needs to be
 **                           passed for a memptr parameter.
 **     HC  20211001          Implementation of i18n support.
+**     ME  20211022          Handle conversion/wrapping for literals when data type is BaseDataType (POLY)
 */
  -->
 
@@ -396,7 +397,7 @@
                <rule>type == prog.string 
                   <!-- if set, get the class from the classname annotation -->
                   <action>classname = getNoteString("classname")</action>
-                  <rule>classname == null
+                  <rule>classname == null or classname.equals("Object")
                      <action>classname = "character"</action>
                   </rule>
                </rule>
@@ -425,6 +426,8 @@
             <rule>classname != "date"        and
                   classname != "datetime"    and
                   classname != "datetimetz"  and
+                  !classname.equals("BaseDataType") and
+                  !classname.equals("Object") and
                   type != prog.unknown_val
                <!-- insert an intermediate constructor node -->
                <action>

=== modified file 'src/com/goldencode/ast/AnnotatedAst.java'
--- src/com/goldencode/ast/AnnotatedAst.java	2021-03-22 09:22:18 +0000
+++ src/com/goldencode/ast/AnnotatedAst.java	2021-10-28 07:59:30 +0000
@@ -218,6 +218,7 @@
 ** 088 CA  20200615          Fixed iterator() when starting from a root with a single child.
 ** 089 CA  20201015          Replaced java.util.Stack with a non-synchronized custom implementation.
 ** 090 IAS 20210321          Added getImmediateChildren(int type) method 
+**     ME  20211025          Avoid NPE on toStringVerbose if text is null.
 */
 
 /*
@@ -3563,7 +3564,10 @@
     */
    public String toStringVerbose()
    {
-      StringBuilder sb = new StringBuilder(getText());
+      StringBuilder sb = new StringBuilder();
+      
+      if (getText() != null)
+         sb.append(getText());
       
       // append the token type as a name
       sb.append(" [").append(getSymbolicTokenType()).append("] ");

=== modified file 'src/com/goldencode/p2j/convert/ExpressionConversionWorker.java'
--- src/com/goldencode/p2j/convert/ExpressionConversionWorker.java	2022-02-07 16:05:16 +0000
+++ src/com/goldencode/p2j/convert/ExpressionConversionWorker.java	2022-02-11 15:26:27 +0000
@@ -222,6 +222,7 @@
 **     HC  20210401          Made isNumericType and isDateType part of the library.
 **     GES 20210610          Added KW_WID_HAND.
 **     HC  20211001          Implementation of i18n support.
+**     ME  20211028          Added the POLY 'virtual' data type.
 **     AL2 20211104          DB_REF_NON_STATIC generates case insensitive values.
 **     CA  20211214          The AST manager plugin must be context-local, for runtime conversion, as the 
 **                           InMemoryRegistryPlugin is not thread-safe.
@@ -1969,21 +1970,18 @@
                case KW_RET_VAL:
                   jcls = "BaseDataType";
                   break;
-                  
+               
                // unexpected *_POLY node, error out here
                default:
-                  if (oldtype == OO_METH_CLASS && source.getText().equalsIgnoreCase("invoke"))
-                  {
-                     String defClass = (String) source.getAnnotation("found-in-cls");
-                     if ("Progress.Lang.Class".equalsIgnoreCase(defClass) || 
-                         "progress.reflect.method".equalsIgnoreCase(defClass))
-                     {
-                        jcls = "BaseDataType";
-                     }
-                     break;
-                  }
-                  errmsg = "Unknown " + source.lookupTokenName(type) + 
-                           " with oldtype of " + source.lookupTokenName(oldtype);
+                  if (type == OO_METH_POLY) 
+                  {
+                     jcls = "BaseDataType";
+                  }
+                  else 
+                  {
+                     errmsg = "Unknown " + source.lookupTokenName(type) + 
+                              " with oldtype of " + source.lookupTokenName(oldtype);
+                  }
             }
             break;
          
@@ -2618,6 +2616,15 @@
          case KW_MEMPTR:
             jcls  = "memptr";
             break;
+         
+         case VAR_POLY:
+         case FUNC_POLY:
+         case ATTR_POLY:
+         case METH_POLY:
+         case OO_METH_POLY:
+         case KW_POLY:
+            jcls  = "Object";
+            break;
             
          case METH_VOID:
          case OO_METH_VOID:

=== modified file 'src/com/goldencode/p2j/oo/core/Assert.java'
--- src/com/goldencode/p2j/oo/core/Assert.java	2021-09-16 09:12:50 +0000
+++ src/com/goldencode/p2j/oo/core/Assert.java	2021-10-13 13:26:10 +0000
@@ -14,6 +14,7 @@
 ** 004 CA  20191024 Added method support levels and updated the class support level.
 ** 005 ME  20201023 Added implementation for isType, notType.
 **     ME  20210916 Delegate to AssertObject as needed.
+**     ME  20210930 Remove use of Apache StringUtils.
 */
 
 /*
@@ -84,8 +85,6 @@
 import static com.goldencode.p2j.util.TextOps.*;
 import static com.goldencode.p2j.util.ErrorManager.silent;
 
-import org.apache.commons.lang3.*;
-
 /**
  * Business logic (converted to Java from the 4GL source code in
  * OpenEdge/Core/Assert.cls).
@@ -567,7 +566,7 @@
       internalProcedure(Assert.class, "IsEmpty", new Block((Body) () -> {
          notNull(_p1, _p2);
          
-         if (!StringUtils.isEmpty(_p1.getValue()))
+         if (!TextOps.isEmpty(_p1))
             returnError(ObjectOps.newInstance(AssertionFailedError.class, "II",
                      substitute("&1 must be empty", _p2), 0));
       }));
@@ -1764,7 +1763,7 @@
    public static void notEmpty(final longchar _p1, final character _p2)
    {
       internalProcedure(Assert.class, "NotEmpty", new Block((Body) () -> {
-         if (!_p1.isUnknown() && StringUtils.isEmpty(_p1.getValue()))
+         if (!_p1.isUnknown() && TextOps.isEmpty(_p1))
             returnError(ObjectOps.newInstance(AssertionFailedError.class, "II",
                      substitute("&1 cannot be empty", _p2), 0));
       }));
@@ -1783,7 +1782,7 @@
       character p2 = TypeFactory.initInput(_p2);
       
       internalProcedure(Assert.class, "NotEmpty", new Block((Body) () -> {
-         if (StringUtils.isEmpty(p1.getValue()))
+         if (TextOps.isEmpty(p1))
             returnError(ObjectOps.newInstance(AssertionFailedError.class, "II",
                      substitute("&1 cannot be empty", p2), 0));
       }));

=== modified file 'src/com/goldencode/p2j/oo/core/ByteBucket.java'
--- src/com/goldencode/p2j/oo/core/ByteBucket.java	2021-09-17 15:14:10 +0000
+++ src/com/goldencode/p2j/oo/core/ByteBucket.java	2022-02-11 15:26:27 +0000
@@ -120,7 +120,7 @@
     */
    public void __core_ByteBucket_execute__()
    {
-      externalProcedure(ByteBucket.this, new Block((Body) () -> {
+      externalProcedure(ByteBucket.class, ByteBucket.this, new Block((Body) () -> {
          onBlockLevel(Condition.ERROR, Action.THROW);
          {
          }
@@ -168,7 +168,7 @@
    {
       int64 var = TypeFactory.initInput(_var);
 
-      internalProcedure(this, "Position", new Block((Body) () -> {
+      internalProcedure(ByteBucket.class, this, "Position", new Block((Body) () -> {
          position.assign(var);
       }));
    }
@@ -213,7 +213,7 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    public void __core_ByteBucket_constructor__()
    {
-      internalProcedure(this, "__core_ByteBucket_constructor__", new Block((Body) () -> {
+      internalProcedure(ByteBucket.class, this, "__core_ByteBucket_constructor__", new Block((Body) () -> {
          __core_ByteBucket_constructor__(new int64(0));
       }));
    }
@@ -231,7 +231,7 @@
    {
       int64 defaultCapacity = TypeFactory.initInput(_defaultCapacity);
       
-      internalProcedure(this, "__core_ByteBucket_constructor__", new Block((Body) () -> {
+      internalProcedure(ByteBucket.class, this, "__core_ByteBucket_constructor__", new Block((Body) () -> {
          __lang_BaseObject_constructor__();
 
          // just throw a 'matching' error for now until implementation is using the new MemoryOutputStream
@@ -272,7 +272,7 @@
 
       integer initialSize = TypeFactory.initInput(_initialSize);
 
-      internalProcedure(this, "__core_ByteBucket_constructor__", new Block((Body) () -> {
+      internalProcedure(ByteBucket.class, this, "__core_ByteBucket_constructor__", new Block((Body) () -> {
          __core_ByteBucket_constructor__();
 
          Assert.isPositive(initialSize, new character("Initial size"));
@@ -305,7 +305,7 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    public void __core_ByteBucket_destructor__()
    {
-      internalProcedure(this, "__core_ByteBucket_destructor__", new Block((Body) () -> {
+      internalProcedure(ByteBucket.class, this, "__core_ByteBucket_destructor__", new Block((Body) () -> {
          destroy();
       }));
    }
@@ -318,7 +318,7 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    public void clear_()
    {
-      internalProcedure(this, "Clear", new Block((Body) () -> {
+      internalProcedure(ByteBucket.class, this, "Clear", new Block((Body) () -> {
          this.position.assign(1);
          this.size.assign(0);
       }));
@@ -332,7 +332,7 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    public void debug()
    {
-      internalProcedure(this, "Debug", new Block((Body) () -> {
+      internalProcedure(ByteBucket.class, this, "Debug", new Block((Body) () -> {
 
          String debugPath = String.format("%sbytebucket-memptr-%d.bin", 
                   EnvironmentOps.getTempDirectory().getValue(), 
@@ -359,7 +359,7 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    public void destroy()
    {
-      internalProcedure(this, "Destroy", new Block((Body) () -> {
+      internalProcedure(ByteBucket.class, this, "Destroy", new Block((Body) () -> {
          this.position.assign(1);
          this.size.setUnknown();
 
@@ -472,7 +472,7 @@
       int64 pos = TypeFactory.initInput(_pos);
       int64 size = TypeFactory.initInput(_size);
       object<? extends Memptr> ret = TypeFactory.object(Memptr.class);
-
+      
       return function(this, "GetBytes", object.class, new Block((Body) () -> {
          if (getSize().longValue() == 0 || size.getValue() == 0)
          {
@@ -481,8 +481,8 @@
          else
          {
             memptr ptr = TypeFactory.memptr();
-   
-            try
+
+            try 
             {
                ptr.setLength(size);
    
@@ -492,11 +492,10 @@
             }
             finally
             {
-               if (ptr.lengthOf() > 0L)
-                  ptr.setLength(0L);
+               ptr.setLength(0L);
             }
          }
-         
+
          returnNormal(ret);
 
       }));
@@ -665,8 +664,7 @@
          }
          finally
          {
-            if (ptr.lengthOf() > 0L)
-               ptr.setLength(0L);
+            ptr.setLength(0L);
          }
       }));
    }
@@ -679,7 +677,7 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    public void initialize()
    {
-      internalProcedure(this, "Initialize", new Block((Body) () -> {
+      internalProcedure(ByteBucket.class, this, "Initialize", new Block((Body) () -> {
          clear_();
       }));
    }
@@ -761,7 +759,7 @@
    {
       object<? extends ByteBucket> data = TypeFactory.initInput(_data);
 
-      internalProcedure(this, "PutBytes", new Block((Body) () -> {
+      internalProcedure(ByteBucket.class, this, "PutBytes", new Block((Body) () -> {
          Assert.notNull(data, new character("Input data"));
 
          ByteBucket bbucket = data.ref();
@@ -797,7 +795,7 @@
       int64 ptr = TypeFactory.initInput(_ptr);
       int64 size = TypeFactory.initInput(_size);
 
-      internalProcedure(this, "PutBytes", new Block((Body) () -> {
+      internalProcedure(ByteBucket.class, this, "PutBytes", new Block((Body) () -> {
 
          if (!size.isUnknown() && size.longValue() == 0L)
             return;
@@ -834,7 +832,7 @@
    {
       memptr ptr = TypeFactory.initInput(_ptr);
 
-      internalProcedure(this, "PutBytes", new Block((Body) () -> {
+      internalProcedure(ByteBucket.class, this, "PutBytes", new Block((Body) () -> {
          writeBytes(ptr);
       }));
    }
@@ -851,7 +849,7 @@
    {
       object<? extends Memptr> mptr = TypeFactory.initInput(_mptr);
 
-      internalProcedure(this, "PutBytes", new Block((Body) () -> {
+      internalProcedure(ByteBucket.class, this, "PutBytes", new Block((Body) () -> {
          Assert.notNull(_mptr, new character("Data"));
 
          putBytes(mptr.ref().getPointerValue(), mptr.ref().getSize());
@@ -870,7 +868,7 @@
    {
       longchar data = TypeFactory.initInput(_data);
 
-      internalProcedure(this, "PutString", new Block((Body) () -> {
+      internalProcedure(ByteBucket.class, this, "PutString", new Block((Body) () -> {
          putString(data, new longchar("UTF-8"));
       }));
    }
@@ -907,7 +905,7 @@
       longchar data = TypeFactory.initInput(_data);
       character targetCP = TypeFactory.initInput(_targetCP);
 
-      internalProcedure(this, "PutString", new Block((Body) () -> {
+      internalProcedure(ByteBucket.class, this, "PutString", new Block((Body) () -> {
          if (TextOps.isEmpty(data))
             return;
 
@@ -941,7 +939,7 @@
    {
       object<? extends LegacyString> data = TypeFactory.initInput(_data);
 
-      internalProcedure(this, "PutString", new Block((Body) () -> {
+      internalProcedure(ByteBucket.class, this, "PutString", new Block((Body) () -> {
          Assert.notNull(data, new character("String data"));
          
          putString(data.ref().getValue(), new longchar(data.ref().getEncoding()));
@@ -988,10 +986,12 @@
    {
       Assert.isPositive(p, new character("Start position"));
 
-      if (CompareOps._isGreaterThan(p, this.getSize())) {
-         ErrorManager.recordOrThrowError(4391,  "Unable to evaluate expression with UNKNOWN value in argument");
+      if (CompareOps._isGreaterThan(p, this.getSize()))
+      {
+         ErrorManager.recordOrThrowError(4391,
+                  "Unable to evaluate expression with UNKNOWN value in argument");
       }
-      
+
       long pos = p.longValue();
       long bytesLeft = data.lengthOf();
       int putAt = 0;
@@ -999,7 +999,6 @@
       int offset = (int) ((pos - 1) % MAX_BYTES_PER_ROW);
       int endBucket = (int) ((size.longValue()) / MAX_BYTES_PER_ROW);
       int endOffset = (int) ((size.longValue()) % MAX_BYTES_PER_ROW);
-      
 
       for (int i = nbucket; i <= endBucket; i++)
       {
@@ -1008,13 +1007,12 @@
 
          if (numBytes > 0)
          {
-            data.write(true, Arrays.copyOfRange(bucket, offset, offset + numBytes), putAt,
-                     false);
+            data.write(true, Arrays.copyOfRange(bucket, offset, offset + numBytes), putAt, false);
 
             offset = 0;
             putAt += numBytes;
             bytesLeft -= numBytes;
-            
+
             if (bytesLeft == 0)
                return;
          }

=== modified file 'src/com/goldencode/p2j/oo/core/LegacyString.java'
--- src/com/goldencode/p2j/oo/core/LegacyString.java	2021-09-16 13:13:54 +0000
+++ src/com/goldencode/p2j/oo/core/LegacyString.java	2021-10-13 13:32:21 +0000
@@ -15,6 +15,7 @@
 **                  signature.
 ** 007 ME  20210520 Set hashCode to return the actual string hashCode.
 **     ME  20210902 Return default hashCode if unknown, fix empty static method and isNullOrEmpty to use trim.
+**     ME  20210929 Fix return value on join/split methods.
 */
 
 /*
@@ -403,28 +404,23 @@
       object<? extends com.goldencode.p2j.oo.core.collections.Array> p1 = TypeFactory
                .initInput(_p1);
       character p2 = TypeFactory.initInput(_p2);
+      object<? extends LegacyString> poRet = TypeFactory.object(LegacyString.class);
 
-      return function(LegacyString.class, "Join", object.class, new Block((Body) () ->
-      {
+      return function(LegacyString.class, "Join", object.class, new Block((Body) () -> {
          object<? extends LegacyClass> clsString = ObjectOps.getLegacyClass(LegacyString.class);
-         // remove the assert to fix the OE BUG
-         Assert.isType(p1, clsString);
 
-         if (p2.isUnknown() || p1.isUnknown())
-         {
-            returnNormal(new longchar());
-         }
-         else
+         if (!p2.isUnknown() && !p1.isUnknown())
          {
             List<String> entries = new ArrayList<String>();
+            boolean hasUnknown = false;
 
             for (int i = 1; i <= p1.ref().getSize().intValue(); i++)
             {
                object<? extends _BaseObject_> c = p1.ref().getValue(new integer(i));
                if (c.isUnknown())
                {
-                  returnNormal(new longchar());
-                  return;
+                  hasUnknown = true;
+                  break;
                }
 
                Assert.isType(c, clsString);
@@ -432,11 +428,15 @@
                entries.add(ObjectOps.cast(c, LegacyString.class).ref().getValue().getValue());
             }
 
-            String join = entries.stream().collect(Collectors.joining(p2.getValue()));
-
-            returnNormal(ObjectOps.newInstance(LegacyString.class, "I", join));
+            if (!hasUnknown) {
+               String join = entries.stream().collect(Collectors.joining(p2.getValue()));
+   
+               poRet.assign(ObjectOps.newInstance(LegacyString.class, "I", join));
+            }
          }
 
+         returnNormal(poRet);
+
       }));
    }
 
@@ -485,30 +485,36 @@
    {
       object<? extends com.goldencode.p2j.oo.core.LegacyString>[] p1 = TypeFactory.initInput(_p1);
       character p2 = TypeFactory.initInput(_p2);
-
+      object<? extends LegacyString> poRet = TypeFactory.object(LegacyString.class);
+      
       return function(LegacyString.class, "Join", object.class, new Block((Body) () -> {
          // indeterminate array or null delimiter 
-         if (p1.length == 0 || p2.isUnknown())
-         {
-            returnNormal(ObjectOps.newInstance(LegacyString.class, "I", new longchar()));
-         }
-         else
-         {
+         if (p1.length > 0 && !p2.isUnknown())
+         {
+            boolean hasUnknown = false;
+            
             for (object<? extends com.goldencode.p2j.oo.core.LegacyString> s : p1)
             {
                // OE does not check for valid objects in array (will throw error)
                // if any of the strings has a null value the result is always null
                if (!s.isUnknown() && s.ref().getValue().isUnknown())
                {
-                  returnNormal(ObjectOps.newInstance(LegacyString.class, "I", new longchar()));
-                  return;
+                  hasUnknown = true;
+                  break;
                }
             }
 
-            returnNormal(ObjectOps.newInstance(LegacyString.class, "I",
-                     Arrays.stream(p1).map(s -> s.ref().getValue().getValue())
+            poRet.assign(ObjectOps.newInstance(LegacyString.class, "I",
+                        hasUnknown ? new character() : Arrays.stream(p1).map(s -> s.ref().getValue().getValue())
                               .collect(Collectors.joining(p2.getValue()))));
          }
+         else 
+         {
+            poRet.assign(ObjectOps.newInstance(LegacyString.class, "I", new character("")));
+         }
+            
+         
+         returnNormal(poRet);
       }));
    }
 
@@ -628,33 +634,35 @@
    {
       object<? extends com.goldencode.p2j.oo.core.LegacyString> p1 = TypeFactory.initInput(_p1);
       character p2 = TypeFactory.initInput(_p2);
+      object<? extends com.goldencode.p2j.oo.core.collections.Array> poRet = TypeFactory
+               .object(com.goldencode.p2j.oo.core.collections.Array.class);
 
-      return function(LegacyString.class, "Split", object.class, new Block((Body) () ->
-      {
+      return function(LegacyString.class, "Split", object.class, new Block((Body) () -> {
 
          if (!p1.isUnknown() && (p2.isUnknown() || p1.ref().getValue().isUnknown()))
          {
             // num-entries is unknown, this will throw assert error
-            returnNormal(ObjectOps.newInstance(com.goldencode.p2j.oo.core.collections.Array.class,
+            poRet.assign(ObjectOps.newInstance(com.goldencode.p2j.oo.core.collections.Array.class,
                      "I", new integer()));
          }
          else
          {
             // 4GL does not test the string object, 3135 system error will be thrown if null
             String[] entries = TextOps.entries(p1.ref().getValue().getValue(), p2.getValue());
-            object<? extends com.goldencode.p2j.oo.core.collections.Array> outputArray = ObjectOps
-                     .newInstance(com.goldencode.p2j.oo.core.collections.Array.class, "I",
-                              entries.length);
+            poRet.assign(ObjectOps.newInstance(com.goldencode.p2j.oo.core.collections.Array.class,
+                     "I", entries.length));
 
             for (int i = 0; i < entries.length; i++)
             {
-               outputArray.ref().setValue(ObjectOps
-                        .newInstance(com.goldencode.p2j.oo.core.LegacyString.class, "I", entries[i]), new integer(i + 1));
+               poRet.ref()
+                        .setValue(ObjectOps.newInstance(
+                                 com.goldencode.p2j.oo.core.LegacyString.class, "I", entries[i]),
+                                 new integer(i + 1));
             }
-            
-            returnNormal(outputArray);
+
          }
 
+         returnNormal(poRet);
       }));
    }
 

=== modified file 'src/com/goldencode/p2j/oo/core/WidgetHandle.java'
--- src/com/goldencode/p2j/oo/core/WidgetHandle.java	2021-02-21 16:25:50 +0000
+++ src/com/goldencode/p2j/oo/core/WidgetHandle.java	2021-10-01 10:52:07 +0000
@@ -10,6 +10,7 @@
 ** 003 CA  20191024 Added method support levels and updated the class support level.
 ** 004 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
 **                  signature.
+**     ME  20211001 Fix toString method, returns unknown if invalid handle.
 */
 
 /*
@@ -236,7 +237,7 @@
    {
       return function(this, "ToString", character.class, new Block((Body) () ->
       {
-         returnNormal(this.value.toStringMessage());
+         returnNormal(character.valueOf(this.value));
       }));
    }
 }

=== modified file 'src/com/goldencode/p2j/oo/core/collections/AbstractTtcollection.java'
--- src/com/goldencode/p2j/oo/core/collections/AbstractTtcollection.java	2021-06-09 14:35:48 +0000
+++ src/com/goldencode/p2j/oo/core/collections/AbstractTtcollection.java	2021-09-28 08:33:36 +0000
@@ -13,6 +13,7 @@
 **                  signature.
 **     CA  20210609 Updated INPUT/INPUT-OUTPUT parameters to the new approach, where they are explicitly 
 **                  initialized at the method's execution, and not at the caller's arguments.
+**     ME  20210928 Fix return value on clone method, defined out of the function block.
 */
 
 /*
@@ -459,8 +460,10 @@
    @Override
    public object<? extends com.goldencode.p2j.oo.lang._BaseObject_> clone()
    {
+      object<? extends Icollection> clone = TypeFactory.object(Icollection.class);
+      
       return function(this, "Clone", object.class, new Block((Body) () -> {
-         object<? extends AbstractTtcollection> clone = ObjectOps.newInstance(getClass());
+         clone.assign(ObjectOps.newInstance(getClass()));
          cloneElements(clone);
          returnNormal(clone);
       }));

